Liblinphone: linphone::CoreListener Class Reference

Liblinphone 5.3.0

Public Member Functions | List of all members
linphone::CoreListener Class Reference

That class holds all the callbacks which are called by Core. More...

`#include <core_listener.hh>`

Inheritance diagram for linphone::CoreListener:

## Public Member Functions
virtual LINPHONECXX_PUBLIC void | onGlobalStateChanged (const std::shared_ptr< linphone::Core > &core, linphone::GlobalState state, const std::string &message)
| Global state notification callback.
virtual LINPHONECXX_PUBLIC void | onRegistrationStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ProxyConfig > &proxyConfig, linphone::RegistrationState state, const std::string &message)
| Registration state notification callback prototype.
virtual LINPHONECXX_PUBLIC void | onConferenceInfoReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< const linphone::ConferenceInfo > &conferenceInfo)
| Callback prototype for notifying the application about a received conference info.
virtual LINPHONECXX_PUBLIC void | onPushNotificationReceived (const std::shared_ptr< linphone::Core > &core, const std::string &payload)
| Callback prototype for notifying the application a push notification was received.
virtual LINPHONECXX_PUBLIC void | onPreviewDisplayErrorOccurred (const std::shared_ptr< linphone::Core > &core, int errorCode)
| Callback to notify that there are errors from the video rendering.
virtual LINPHONECXX_PUBLIC void | onCallStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, linphone::Call::State state, const std::string &message)
| Call state notification callback.
virtual LINPHONECXX_PUBLIC void | onNotifyPresenceReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Friend > &linphoneFriend)
| Report status change for a friend previously added to the Core with linphone_core_add_friend().
virtual LINPHONECXX_PUBLIC void | onNotifyPresenceReceivedForUriOrTel (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Friend > &linphoneFriend, const std::string &uriOrTel, const std::shared_ptr< const linphone::PresenceModel > &presenceModel)
| Reports presence model change for a specific URI or phone number of a friend.
virtual LINPHONECXX_PUBLIC void | onNewSubscriptionRequested (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Friend > &linphoneFriend, const std::string &url)
| Reports that a new subscription request has been received and wait for a decision.
virtual LINPHONECXX_PUBLIC void | onAuthenticationRequested (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::AuthInfo > &authInfo, linphone::AuthMethod method)
| Callback for requesting authentication information to application or user.
virtual LINPHONECXX_PUBLIC void | onCallLogUpdated (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::CallLog > &callLog)
| Callback to notify a new call-log entry has been added.
virtual LINPHONECXX_PUBLIC void | onCallIdUpdated (const std::shared_ptr< linphone::Core > &core, const std::string &previousCallId, const std::string &currentCallId)
| Callback to notify the callid of a call has been updated.
virtual LINPHONECXX_PUBLIC void | onMessageReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::shared_ptr< linphone::ChatMessage > &message)
| Chat message callback prototype.
virtual LINPHONECXX_PUBLIC void | onNewMessageReaction (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::shared_ptr< linphone::ChatMessage > &message, const std::shared_ptr< const linphone::ChatMessageReaction > &reaction)
| Chat message new reaction callback prototype.
virtual LINPHONECXX_PUBLIC void | onReactionRemoved (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::shared_ptr< linphone::ChatMessage > &message, const std::shared_ptr< const linphone::Address > &address)
| Chat message removed reaction callback prototype.
virtual LINPHONECXX_PUBLIC void | onMessagesReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::list< std::shared_ptr< linphone::ChatMessage > > &messages)
| Chat messages callback prototype.
virtual LINPHONECXX_PUBLIC void | onMessageSent (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::shared_ptr< linphone::ChatMessage > &message)
| Called after the ChatMessage::send() was called.
virtual LINPHONECXX_PUBLIC void | onChatRoomSessionStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, linphone::Call::State state, const std::string &message)
| Chat room session state changed callback.
virtual LINPHONECXX_PUBLIC void | onChatRoomRead (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom)
| Chat room marked as read callback.
virtual LINPHONECXX_PUBLIC void | onMessageReceivedUnableDecrypt (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, const std::shared_ptr< linphone::ChatMessage > &message)
| Chat message not decrypted callback prototype.
virtual LINPHONECXX_PUBLIC void | onIsComposingReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom)
| Is composing notification callback prototype.
virtual LINPHONECXX_PUBLIC void | onDtmfReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, int dtmf)
| Callback for being notified of DTMFs received.
virtual LINPHONECXX_PUBLIC void | onReferReceived (const std::shared_ptr< linphone::Core > &core, const std::string &referTo)
| Callback prototype for when a refer is received.
virtual LINPHONECXX_PUBLIC void | onCallGoclearAckSent (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call)
| GoClear ACK sent on call callback.
virtual LINPHONECXX_PUBLIC void | onCallEncryptionChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, bool mediaEncryptionEnabled, const std::string &authenticationToken)
| Call encryption changed callback.
virtual LINPHONECXX_PUBLIC void | onCallSendMasterKeyChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, const std::string &masterKey)
| Call send master key changed callback.
virtual LINPHONECXX_PUBLIC void | onCallReceiveMasterKeyChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, const std::string &masterKey)
| Call receive master key changed callback.
virtual LINPHONECXX_PUBLIC void | onTransferStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &transfered, linphone::Call::State callState)
| Callback for notifying progresses of transfers.
virtual LINPHONECXX_PUBLIC void | onBuddyInfoUpdated (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Friend > &linphoneFriend)
| Callback prototype when using the buddy plugin.
virtual LINPHONECXX_PUBLIC void | onCallStatsUpdated (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, const std::shared_ptr< const linphone::CallStats > &callStats)
| Callback for receiving quality statistics for calls.
virtual LINPHONECXX_PUBLIC void | onInfoReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call, const std::shared_ptr< const linphone::InfoMessage > &message)
| Callback prototype for receiving info messages.
virtual LINPHONECXX_PUBLIC void | onSubscriptionStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, linphone::SubscriptionState state)
| Callback prototype for notifying the application about changes of subscription states, including arrival of new subscriptions.
virtual LINPHONECXX_PUBLIC void | onNotifySent (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, const std::shared_ptr< const linphone::Content > &body)
| Callback prototype for notifying the application about notification that is being sent.
virtual LINPHONECXX_PUBLIC void | onNotifyReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, const std::string &notifiedEvent, const std::shared_ptr< const linphone::Content > &body)
| Callback prototype for notifying the application about notification received from the network.
virtual LINPHONECXX_PUBLIC void | onSubscribeReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, const std::string &subscribeEvent, const std::shared_ptr< const linphone::Content > &body)
| Callback prototype for notifying the application about subscription received from the network.
virtual LINPHONECXX_PUBLIC void | onPublishStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, linphone::PublishState state)
| Callback prototype for notifying the application about changes of publish states.
virtual LINPHONECXX_PUBLIC void | onPublishReceived (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Event > &linphoneEvent, const std::string &publishEvent, const std::shared_ptr< const linphone::Content > &body)
| Callback prototype for notifying the application about publish received from the network.
virtual LINPHONECXX_PUBLIC void | onConfiguringStatus (const std::shared_ptr< linphone::Core > &core, linphone::ConfiguringState status, const std::string &message)
| Callback prototype for configuring status changes notification.
virtual LINPHONECXX_PUBLIC void | onNetworkReachable (const std::shared_ptr< linphone::Core > &core, bool reachable)
| Callback prototype for reporting network change either automatically detected or notified by Core::setNetworkReachable().
virtual LINPHONECXX_PUBLIC void | onLogCollectionUploadStateChanged (const std::shared_ptr< linphone::Core > &core, linphone::Core::LogCollectionUploadState state, const std::string &info)
| Callback prototype for reporting log collection upload state change.
virtual LINPHONECXX_PUBLIC void | onLogCollectionUploadProgressIndication (const std::shared_ptr< linphone::Core > &core, size_t offset, size_t total)
| Callback prototype for reporting log collection upload progress indication.
virtual LINPHONECXX_PUBLIC void | onFriendListCreated (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::FriendList > &friendList)
| Callback prototype for reporting when a friend list has been added to the core friend lists.
virtual LINPHONECXX_PUBLIC void | onFriendListRemoved (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::FriendList > &friendList)
| Callback prototype for reporting when a friend list has been removed from the core friend lists.
virtual LINPHONECXX_PUBLIC void | onCallCreated (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Call > &call)
| Callback notifying that a new Call (either incoming or outgoing) has been created.
virtual LINPHONECXX_PUBLIC void | onVersionUpdateCheckResultReceived (const std::shared_ptr< linphone::Core > &core, linphone::VersionUpdateCheckResult result, const std::string &version, const std::string &url)
| Callback prototype for reporting the result of a version update check.
virtual LINPHONECXX_PUBLIC void | onConferenceStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Conference > &conference, linphone::Conference::State state)
| Callback prototype telling that a Conference state has changed.
virtual LINPHONECXX_PUBLIC void | onChatRoomStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom, linphone::ChatRoom::State state)
| Callback prototype telling that a ChatRoom state has changed.
virtual LINPHONECXX_PUBLIC void | onChatRoomSubjectChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom)
| Callback prototype telling that a ChatRoom subject has changed.
virtual LINPHONECXX_PUBLIC void | onChatRoomEphemeralMessageDeleted (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::ChatRoom > &chatRoom)
| Callback prototype telling that a ChatRoom ephemeral message has expired.
virtual LINPHONECXX_PUBLIC void | onImeeUserRegistration (const std::shared_ptr< linphone::Core > &core, const bool status, const std::string &userId, const std::string &info)
| Callback prototype telling that an Instant Message Encryption Engine user registered on the server with or without success.
virtual LINPHONECXX_PUBLIC void | onQrcodeFound (const std::shared_ptr< linphone::Core > &core, const std::string &result)
| Callback prototype telling the result of decoded qrcode.
virtual LINPHONECXX_PUBLIC void | onFirstCallStarted (const std::shared_ptr< linphone::Core > &core)
| Callback prototype telling a call has started (incoming or outgoing) while there was no other call.
virtual LINPHONECXX_PUBLIC void | onLastCallEnded (const std::shared_ptr< linphone::Core > &core)
| Callback prototype telling the last call has ended (Core::getCallsNb() returns 0).
virtual LINPHONECXX_PUBLIC void | onAudioDeviceChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::AudioDevice > &audioDevice)
| Callback prototype telling that the audio device for at least one call has changed.
virtual LINPHONECXX_PUBLIC void | onAudioDevicesListUpdated (const std::shared_ptr< linphone::Core > &core)
| Callback prototype telling the audio devices list has been updated.
virtual LINPHONECXX_PUBLIC void | onEcCalibrationResult (const std::shared_ptr< linphone::Core > &core, linphone::EcCalibratorStatus status, int delayMs)
| Function prototype used by linphone_core_cbs_set_ec_calibration_result.
virtual LINPHONECXX_PUBLIC void | onEcCalibrationAudioInit (const std::shared_ptr< linphone::Core > &core)
| Function prototype used by linphone_core_cbs_set_ec_calibration_audio_init.
virtual LINPHONECXX_PUBLIC void | onEcCalibrationAudioUninit (const std::shared_ptr< linphone::Core > &core)
| Function prototype used by linphone_core_cbs_set_ec_calibration_audio_uninit.
virtual LINPHONECXX_PUBLIC void | onAccountRegistrationStateChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Account > &account, linphone::RegistrationState state, const std::string &message)
| Callback notifying that a Account has its registration state changed.
virtual LINPHONECXX_PUBLIC void | onDefaultAccountChanged (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Account > &account)
| Default account changed callback prototype.
virtual LINPHONECXX_PUBLIC void | onAccountAdded (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Account > &account)
| Account added callback prototype.
virtual LINPHONECXX_PUBLIC void | onAccountRemoved (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Account > &account)
| Account removed callback prototype.
virtual LINPHONECXX_PUBLIC void | onNewAlertTriggered (const std::shared_ptr< linphone::Core > &core, const std::shared_ptr< linphone::Alert > &alert)
| Callback for notifying about an alert (e.g on Qos).

## Detailed Description

That class holds all the callbacks which are called by Core.

Once created, add your CoreListener using Core::addListener(). Keep a reference on it as long as you need it. You can use Core::removeListener() to remove it but that isn't mandatory. The same applies to all listeners in our API.

## Member Function Documentation

## ◆ onAccountAdded()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAccountAdded | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Account > & | account )
| inlinevirtual

Account added callback prototype.

Parameters

  core | Core object
  account | Account object that has been added to the Core using Core::addAccount() for example.

## ◆ onAccountRegistrationStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAccountRegistrationStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Account > & | account,
|  | linphone::RegistrationState | state,
|  | const std::string & | message )
| inlinevirtual

Callback notifying that a Account has its registration state changed.

Parameters

  core | The Core object.
  account | The Account object which has its registration changed.
  state | The new RegistrationState for this account.
  message | a non nullptr informational message about the state

## ◆ onAccountRemoved()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAccountRemoved | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Account > & | account )
| inlinevirtual

Account removed callback prototype.

Parameters

  core | Core object
  account | Account object that has been added to the Core using Core::removeAccount() for example.

## ◆ onAudioDeviceChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAudioDeviceChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::AudioDevice > & | audioDevice )
| inlinevirtual

Callback prototype telling that the audio device for at least one call has changed.

Parameters

  core | LinphoneCore object
  audioDevice | the newly used LinphoneAudioDevice object

## ◆ onAudioDevicesListUpdated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAudioDevicesListUpdated | ( | const std::shared_ptr< linphone::Core > & | core | ) |
| inlinevirtual

Callback prototype telling the audio devices list has been updated.

Either a new device is available or a previously available device isn't anymore. You can call Core::getAudioDevices() to get the new list.

Parameters

  core | Core object

## ◆ onAuthenticationRequested()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onAuthenticationRequested | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::AuthInfo > & | authInfo,
|  | linphone::AuthMethod | method )
| inlinevirtual

Callback for requesting authentication information to application or user.

Parameters

  core | the Core
  authInfo | a AuthInfo pre-filled with username, realm and domain values as much as possible
  method | the type of authentication requested as AuthMethod enum Application shall reply to this callback using Core::addAuthInfo().

## ◆ onBuddyInfoUpdated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onBuddyInfoUpdated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Friend > & | linphoneFriend )
| inlinevirtual

Callback prototype when using the buddy plugin.

Parameters

  core | the Core
  linphoneFriend | the Friend that has been updated

## ◆ onCallCreated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallCreated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call )
| inlinevirtual

Callback notifying that a new Call (either incoming or outgoing) has been created.

Parameters

  core | Core object that has created the call
  call | The newly created Call object

## ◆ onCallEncryptionChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallEncryptionChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | bool | mediaEncryptionEnabled,
|  | const std::string & | authenticationToken )
| inlinevirtual

Call encryption changed callback.

Parameters

  core | the Core
  call | the Call on which encryption is changed.
  mediaEncryptionEnabled | whether encryption is activated.
  authenticationToken | an authentication token, currently set for ZRTP kind of encryption only.

## ◆ onCallGoclearAckSent()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallGoclearAckSent | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call )
| inlinevirtual

GoClear ACK sent on call callback.

Parameters

  core | the Core
  call | the Call on which the GoClear ACK was sent.

## ◆ onCallIdUpdated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallIdUpdated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::string & | previousCallId,
|  | const std::string & | currentCallId )
| inlinevirtual

Callback to notify the callid of a call has been updated.

This is done typically when a call retry.

Parameters

  core | the Core
  previousCallId | the previous callid.
  currentCallId | the new callid.

## ◆ onCallLogUpdated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallLogUpdated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::CallLog > & | callLog )
| inlinevirtual

Callback to notify a new call-log entry has been added.

This is done typically when a call terminates.

Parameters

  core | the Core
  callLog | the new CallLog entry added.

## ◆ onCallReceiveMasterKeyChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallReceiveMasterKeyChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | const std::string & | masterKey )
| inlinevirtual

Call receive master key changed callback.

Parameters

  core | the Core
  call | the Call on which the GoClear ACK was sent.
  masterKey | new master key.

## ◆ onCallSendMasterKeyChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallSendMasterKeyChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | const std::string & | masterKey )
| inlinevirtual

Call send master key changed callback.

Parameters

  core | the Core
  call | the Call on which the GoClear ACK was sent.
  masterKey | new master key.

## ◆ onCallStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | linphone::Call::State | state,
|  | const std::string & | message )
| inlinevirtual

Call state notification callback.

Parameters

  core | the Core
  call | the Call object whose state is changed.
  state | the new Call::State of the call
  message | a non nullptr informational message about the state.

## ◆ onCallStatsUpdated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onCallStatsUpdated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | const std::shared_ptr< const linphone::CallStats > & | callStats )
| inlinevirtual

Callback for receiving quality statistics for calls.

Parameters

  core | the Core
  call | the Call
  callStats | the CallStats statistics.

## ◆ onChatRoomEphemeralMessageDeleted()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onChatRoomEphemeralMessageDeleted | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom )
| inlinevirtual

Callback prototype telling that a ChatRoom ephemeral message has expired.

Parameters

  core | Core object
  chatRoom | The ChatRoom object for which a message has expired.

## ◆ onChatRoomRead()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onChatRoomRead | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom )
| inlinevirtual

Chat room marked as read callback.

Parameters

  core | Core object
  chatRoom | ChatRoom that has been marked as read.

## ◆ onChatRoomSessionStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onChatRoomSessionStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | linphone::Call::State | state,
|  | const std::string & | message )
| inlinevirtual

Chat room session state changed callback.

Parameters

  core | Core object
  chatRoom | ChatRoom that has been marked as read.
  state | the new Call::State of the call
  message | a non nullptr informational message about the state.

## ◆ onChatRoomStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onChatRoomStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | linphone::ChatRoom::State | state )
| inlinevirtual

Callback prototype telling that a ChatRoom state has changed.

Parameters

  core | Core object
  chatRoom | The ChatRoom object for which the state has changed
  state | the current ChatRoom::State

## ◆ onChatRoomSubjectChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onChatRoomSubjectChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom )
| inlinevirtual

Callback prototype telling that a ChatRoom subject has changed.

Parameters

  core | Core object
  chatRoom | The ChatRoom object for which the subject has changed

## ◆ onConferenceInfoReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onConferenceInfoReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< const linphone::ConferenceInfo > & | conferenceInfo )
| inlinevirtual

Callback prototype for notifying the application about a received conference info.

Parameters

  core | Core object
  conferenceInfo | the ConferenceInfo received

## ◆ onConferenceStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onConferenceStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Conference > & | conference,
|  | linphone::Conference::State | state )
| inlinevirtual

Callback prototype telling that a Conference state has changed.

Parameters

  core | Core object
  conference | The Conference object for which the state has changed
  state | the current ChatRoom::State

## ◆ onConfiguringStatus()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onConfiguringStatus | ( | const std::shared_ptr< linphone::Core > & | core,
|  | linphone::ConfiguringState | status,
|  | const std::string & | message )
| inlinevirtual

Callback prototype for configuring status changes notification.

Parameters

  core | the Core
  status | the current ConfiguringState
  message | informational message.

## ◆ onDefaultAccountChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onDefaultAccountChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Account > & | account )
| inlinevirtual

Default account changed callback prototype.

Parameters

  core | Core object
  account | Account object that has been set as the default account, probably by calling Core::setDefaultAccount(), or nullptr if the default account was removed.

## ◆ onDtmfReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onDtmfReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | int | dtmf )
| inlinevirtual

Callback for being notified of DTMFs received.

Parameters

  core | the LinphoneCore
  call | the LinphoneCall that received the dtmf
  dtmf | the ascii code of the dtmf

## ◆ onEcCalibrationAudioInit()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onEcCalibrationAudioInit | ( | const std::shared_ptr< linphone::Core > & | core | ) |
| inlinevirtual

Function prototype used by linphone_core_cbs_set_ec_calibration_audio_init.

Parameters

  core | The Core.

## ◆ onEcCalibrationAudioUninit()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onEcCalibrationAudioUninit | ( | const std::shared_ptr< linphone::Core > & | core | ) |
| inlinevirtual

Function prototype used by linphone_core_cbs_set_ec_calibration_audio_uninit.

Parameters

  core | The Core.

## ◆ onEcCalibrationResult()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onEcCalibrationResult | ( | const std::shared_ptr< linphone::Core > & | core,
|  | linphone::EcCalibratorStatus | status,
|  | int | delayMs )
| inlinevirtual

Function prototype used by linphone_core_cbs_set_ec_calibration_result.

Parameters

  core | The Core.
  status | The EcCalibratorStatus of the calibrator.
  delayMs | The measured delay if available.

## ◆ onFirstCallStarted()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onFirstCallStarted | ( | const std::shared_ptr< linphone::Core > & | core | ) |
| inlinevirtual

Callback prototype telling a call has started (incoming or outgoing) while there was no other call.

Parameters

  core | Core object

## ◆ onFriendListCreated()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onFriendListCreated | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::FriendList > & | friendList )
| inlinevirtual

Callback prototype for reporting when a friend list has been added to the core friend lists.

Parameters

  core | Core object
  friendList | FriendList object

## ◆ onFriendListRemoved()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onFriendListRemoved | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::FriendList > & | friendList )
| inlinevirtual

Callback prototype for reporting when a friend list has been removed from the core friend lists.

Parameters

  core | Core object
  friendList | FriendList object

## ◆ onGlobalStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onGlobalStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | linphone::GlobalState | state,
|  | const std::string & | message )
| inlinevirtual

Global state notification callback.

Parameters

  core | the Core.
  state | the GlobalState
  message | informational message.

## ◆ onImeeUserRegistration()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onImeeUserRegistration | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const bool | status,
|  | const std::string & | userId,
|  | const std::string & | info )
| inlinevirtual

Callback prototype telling that an Instant Message Encryption Engine user registered on the server with or without success.

Parameters

  core | Core object
  status | the return status of the registration action.
  userId | the userId published on the encryption engine server
  info | information about failure

## ◆ onInfoReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onInfoReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | call,
|  | const std::shared_ptr< const linphone::InfoMessage > & | message )
| inlinevirtual

Callback prototype for receiving info messages.

Parameters

  core | the Core
  call | the call whose info message belongs to.
  message | the info message.

## ◆ onIsComposingReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onIsComposingReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom )
| inlinevirtual

Is composing notification callback prototype.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in the conversation.

## ◆ onLastCallEnded()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onLastCallEnded | ( | const std::shared_ptr< linphone::Core > & | core | ) |
| inlinevirtual

Callback prototype telling the last call has ended (Core::getCallsNb() returns 0).

Parameters

  core | Core object

## ◆ onLogCollectionUploadProgressIndication()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onLogCollectionUploadProgressIndication | ( | const std::shared_ptr< linphone::Core > & | core,
|  | size_t | offset,
|  | size_t | total )
| inlinevirtual

Callback prototype for reporting log collection upload progress indication.

Parameters

  core | Core object
  offset | the number of bytes sent since the start of the upload
  total | the total number of bytes to upload

## ◆ onLogCollectionUploadStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onLogCollectionUploadStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | linphone::Core::LogCollectionUploadState | state,
|  | const std::string & | info )
| inlinevirtual

Callback prototype for reporting log collection upload state change.

Parameters

  core | Core object
  state | The state of the log collection upload
  info | Additional information: error message in case of error state, URL of uploaded file in case of success.

## ◆ onMessageReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onMessageReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::shared_ptr< linphone::ChatMessage > & | message )
| inlinevirtual

Chat message callback prototype.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be created by the framework in case the From-URI is not present in any chat room.
  message | ChatMessage incoming message

## ◆ onMessageReceivedUnableDecrypt()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onMessageReceivedUnableDecrypt | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::shared_ptr< linphone::ChatMessage > & | message )
| inlinevirtual

Chat message not decrypted callback prototype.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be be created by the framework in case the from-URI is not present in any chat room.
  message | ChatMessage incoming message

## ◆ onMessageSent()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onMessageSent | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::shared_ptr< linphone::ChatMessage > & | message )
| inlinevirtual

Called after the ChatMessage::send() was called.

The message will be in state InProgress. In case of resend this callback won't be called.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be be created by the framework in case the From-URI is not present in any chat room.
  message | ChatMessage outgoing message

## ◆ onMessagesReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onMessagesReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::list< std::shared_ptr< linphone::ChatMessage > > & | messages )
| inlinevirtual

Chat messages callback prototype.

Only called when aggregation is enabled (aka [sip] chat_messages_aggregation == 1 or using Core::setChatMessagesAggregationEnabled()), it replaces the single message received callback.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be created by the framework in case the From-URI is not present in any chat room.
  messages | The of incoming messages

## ◆ onNetworkReachable()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNetworkReachable | ( | const std::shared_ptr< linphone::Core > & | core,
|  | bool | reachable )
| inlinevirtual

Callback prototype for reporting network change either automatically detected or notified by Core::setNetworkReachable().

Parameters

  core | the Core
  reachable | true if network is reachable.

## ◆ onNewAlertTriggered()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNewAlertTriggered | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Alert > & | alert )
| inlinevirtual

Callback for notifying about an alert (e.g on Qos).

Parameters

  core | Core object
  alert | Alert to notify

## ◆ onNewMessageReaction()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNewMessageReaction | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::shared_ptr< linphone::ChatMessage > & | message,
|  | const std::shared_ptr< const linphone::ChatMessageReaction > & | reaction )
| inlinevirtual

Chat message new reaction callback prototype.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be created by the framework in case the From-URI is not present in any chat room.
  message | the ChatMessage to which the reaction applies to
  reaction | the ChatMessageReaction that has been sent or received

## ◆ onNewSubscriptionRequested()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNewSubscriptionRequested | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Friend > & | linphoneFriend,
|  | const std::string & | url )
| inlinevirtual

Reports that a new subscription request has been received and wait for a decision.

Note
  A subscription request is notified by this function only if the SubscribePolicy for the given Friend has been set to SubscribePolicy::SPWait. See Friend::setIncSubscribePolicy().

Parameters

  core | Core object
  linphoneFriend | The Friend aimed by the subscription.
  url | URI of the subscriber

## ◆ onNotifyPresenceReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNotifyPresenceReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Friend > & | linphoneFriend )
| inlinevirtual

Report status change for a friend previously added to the Core with linphone_core_add_friend().

Parameters

  core | Core object
  linphoneFriend | Updated Friend

## ◆ onNotifyPresenceReceivedForUriOrTel()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNotifyPresenceReceivedForUriOrTel | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Friend > & | linphoneFriend,
|  | const std::string & | uriOrTel,
|  | const std::shared_ptr< const linphone::PresenceModel > & | presenceModel )
| inlinevirtual

Reports presence model change for a specific URI or phone number of a friend.

Parameters

  core | Core object
  linphoneFriend | Friend object
  uriOrTel | The URI or phone number for which the presence model has changed
  presenceModel | The new PresenceModel

## ◆ onNotifyReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNotifyReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | const std::string & | notifiedEvent,
|  | const std::shared_ptr< const linphone::Content > & | body )
| inlinevirtual

Callback prototype for notifying the application about notification received from the network.

Parameters

  core | Core object
  linphoneEvent | the Event received
  notifiedEvent | The event as string
  body | the Content of the event

## ◆ onNotifySent()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onNotifySent | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | const std::shared_ptr< const linphone::Content > & | body )
| inlinevirtual

Callback prototype for notifying the application about notification that is being sent.

Parameters

  core | Core object
  linphoneEvent | the Event received
  body | the Content of the event

## ◆ onPreviewDisplayErrorOccurred()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onPreviewDisplayErrorOccurred | ( | const std::shared_ptr< linphone::Core > & | core,
|  | int | errorCode )
| inlinevirtual

Callback to notify that there are errors from the video rendering.

Check LinphoneCallCbsVideoDisplayErrorOccurredCb for more details.

Parameters

  core | Core object
  errorCode | The error code. It depends of the display filter (available for OpenGL)

## ◆ onPublishReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onPublishReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | const std::string & | publishEvent,
|  | const std::shared_ptr< const linphone::Content > & | body )
| inlinevirtual

Callback prototype for notifying the application about publish received from the network.

Parameters

  core | Core object
  linphoneEvent | the Event received
  publishEvent | The event as string
  body | the Content of the event

## ◆ onPublishStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onPublishStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | linphone::PublishState | state )
| inlinevirtual

Callback prototype for notifying the application about changes of publish states.

Parameters

  core | Core object
  linphoneEvent | the Event
  state | the new PublishState

## ◆ onPushNotificationReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onPushNotificationReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::string & | payload )
| inlinevirtual

Callback prototype for notifying the application a push notification was received.

On iOS it only works with pushkit (VoIP) pushes.

Parameters

  core | Core object
  payload | the body of the push notification, if any

## ◆ onQrcodeFound()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onQrcodeFound | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::string & | result )
| inlinevirtual

Callback prototype telling the result of decoded qrcode.

Parameters

  core | Core object
  result | The result of the decoded qrcode

## ◆ onReactionRemoved()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onReactionRemoved | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ChatRoom > & | chatRoom,
|  | const std::shared_ptr< linphone::ChatMessage > & | message,
|  | const std::shared_ptr< const linphone::Address > & | address )
| inlinevirtual

Chat message removed reaction callback prototype.

Parameters

  core | Core object
  chatRoom | ChatRoom involved in this conversation. Can be created by the framework in case the From-URI is not present in any chat room.
  message | the ChatMessage to which a reaction has been removed from
  address | the Address of the person that removed it's reaction

## ◆ onReferReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onReferReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::string & | referTo )
| inlinevirtual

Callback prototype for when a refer is received.

Parameters

  core | the Core
  referTo | the address of the refer

## ◆ onRegistrationStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onRegistrationStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::ProxyConfig > & | proxyConfig,
|  | linphone::RegistrationState | state,
|  | const std::string & | message )
| inlinevirtual

Registration state notification callback prototype.

Parameters

  core | the Core
  proxyConfig | the ProxyConfig which state has changed
  state | the current RegistrationState
  message | a non nullptr informational message about the state

Deprecated
  06/04/2020 Use LinphoneCoreCbsAccountRegistrationStateChangedCb instead

## ◆ onSubscribeReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onSubscribeReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | const std::string & | subscribeEvent,
|  | const std::shared_ptr< const linphone::Content > & | body )
| inlinevirtual

Callback prototype for notifying the application about subscription received from the network.

Parameters

  core | Core object
  linphoneEvent | the Event received
  subscribeEvent | The event as string
  body | the Content of the event

## ◆ onSubscriptionStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onSubscriptionStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Event > & | linphoneEvent,
|  | linphone::SubscriptionState | state )
| inlinevirtual

Callback prototype for notifying the application about changes of subscription states, including arrival of new subscriptions.

Parameters

  core | Core object
  linphoneEvent | the Event
  state | the new SubscriptionState

## ◆ onTransferStateChanged()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onTransferStateChanged | ( | const std::shared_ptr< linphone::Core > & | core,
|  | const std::shared_ptr< linphone::Call > & | transfered,
|  | linphone::Call::State | callState )
| inlinevirtual

Callback for notifying progresses of transfers.

Parameters

  core | the LinphoneCore
  transfered | the LinphoneCall that was transfered
  callState | the LinphoneCallState of the call to transfer target at the far end.

## ◆ onVersionUpdateCheckResultReceived()

virtual LINPHONECXX_PUBLIC void linphone::CoreListener::onVersionUpdateCheckResultReceived | ( | const std::shared_ptr< linphone::Core > & | core,
|  | linphone::VersionUpdateCheckResult | result,
|  | const std::string & | version,
|  | const std::string & | url )
| inlinevirtual

Callback prototype for reporting the result of a version update check.

Parameters

  core | Core object
  result | The result of the version update check
  version | The version to update to
  url | The url where to download the new version if the result is #LinphoneVersionUpdateCheckNewVersionAvailable

The documentation for this class was generated from the following file:

- core_listener.hh